import os
import sys
import squish_py_util

from multiprocessing.managers import BaseManager

remote_host = "127.0.0.1"
remote_port = 8989
remote_password = "MeineGeheimesPassword"

def get_file_remote( remote_host, remote_port, remote_password, remote_file_name, local_file_name ):
    mgr = BaseManager( address=( remote_host, remote_port ), authkey=remote_password )
    mgr.connect()

    print 'Fetching remote file "%s" to "%s"' % ( remote_file_name, local_file_name )
    contents, error_message = mgr.get_file( remote_file_name )._getvalue()

    if error_message is not None:
        print "ERROR: %s" % error_message
        sys.exit( 11 )

    try:
        f = open( local_file_name, "wb" )
        f.write( contents )
        f.close()
    except Exception as e:
        print "ERROR: Opening/writing file failed: %s: %s" % ( local_file_name, e )
        sys.exit( 12 )

def put_file_remote( remote_host, remote_port, remote_password, local_file_name, remote_file_name ):
    mgr = BaseManager( address=( remote_host, remote_port ), authkey=remote_password )
    mgr.connect()

    print 'Putting local file "%s" to "%s"' % ( local_file_name, remote_file_name )
    try:
        f = open( local_file_name, "rb" )
        c = f.read()
        f.close()
    except Exception as e:
        print "ERROR: Opening/reading file failed: %s: %s" % ( local_file_name, e )
        sys.exit( 21 )
    error_message = mgr.put_file( remote_file_name, c )._getvalue()

    if error_message is not None:
        print "ERROR: %s" % error_message
        sys.exit( 22 )

def print_usage():
    print "USAGE:"
    print
    print "  python %s put <local_file_name> <remote_file_name>" % sys.argv[ 0 ]
    print "  python %s get <remote_file_name> <local_file_name>" % sys.argv[ 0 ]

if __name__ == "__main__":
    if "SQUISH_PREFIX" in os.environ:
        squishpyutil.remove_squish_paths_and_run_again( os.environ[ "SQUISH_PREFIX" ] )
    elif len( sys.argv ) == 4:
        if sys.argv[ 1 ] not in [ "get", "put" ]:
            print "ERROR: Unsupported command: %s" % sys.argv[ 1 ]
            print_usage()
            sys.exit( 1 )

        BaseManager.register( "get_file" )
        remote_file_name = sys.argv[ 2 ]
        local_file_name = sys.argv[ 3 ]
        get_file_remote( remote_host, remote_port, remote_password, remote_file_name, local_file_name )

        BaseManager.register( "put_file" )
        local_file_name = sys.argv[ 2 ]
        remote_file_name = sys.argv[ 3 ]
        put_file_remote( remote_host, remote_port, remote_password, local_file_name, remote_file_name )
    else:
        print_usage()
